#ifndef INC_SourceLexer_hpp_
#define INC_SourceLexer_hpp_

#include <antlr/config.hpp>
/* $ANTLR 2.7.5 (20050201): "parser.g" -> "SourceLexer.hpp"$ */
#include <antlr/CommonToken.hpp>
#include <antlr/InputBuffer.hpp>
#include <antlr/BitSet.hpp>
#include "SourceParserTokenTypes.hpp"
#include <antlr/CharScanner.hpp>
#line 10 "parser.g"

	#include <iostream>

	#include "CodeGenerator.h"
	#include "Symbols.h"
	#include "Utilities.h"
	
	using namespace std;
	using namespace Compiler;

#line 23 "SourceLexer.hpp"
#line 6 "parser.g"

	#include "ANTLRExt.h"

#line 28 "SourceLexer.hpp"
class CUSTOM_API SourceLexer : public ANTLR_USE_NAMESPACE(antlr)CharScanner, public SourceParserTokenTypes
{
#line 1 "parser.g"
#line 32 "SourceLexer.hpp"
private:
	void initLiterals();
public:
	bool getCaseSensitiveLiterals() const
	{
		return true;
	}
public:
	SourceLexer(ANTLR_USE_NAMESPACE(std)istream& in);
	SourceLexer(ANTLR_USE_NAMESPACE(antlr)InputBuffer& ib);
	SourceLexer(const ANTLR_USE_NAMESPACE(antlr)LexerSharedInputState& state);
	ANTLR_USE_NAMESPACE(antlr)RefToken nextToken();
	public: void mWS(bool _createToken);
	public: void mLCURLY(bool _createToken);
	public: void mRCURLY(bool _createToken);
	public: void mLPAREN(bool _createToken);
	public: void mRPAREN(bool _createToken);
	public: void mSTAR(bool _createToken);
	public: void mDIVIDE(bool _createToken);
	public: void mPLUS(bool _createToken);
	public: void mMINUS(bool _createToken);
	public: void mMODULO(bool _createToken);
	public: void mSEMI(bool _createToken);
	public: void mLBRACKET(bool _createToken);
	public: void mRBRACKET(bool _createToken);
	public: void mCOMMA(bool _createToken);
	public: void mDOT(bool _createToken);
	public: void mARROW(bool _createToken);
	public: void mTK_LT(bool _createToken);
	public: void mGT(bool _createToken);
	public: void mLE(bool _createToken);
	public: void mGE(bool _createToken);
	public: void mEQ(bool _createToken);
	public: void mNEQ(bool _createToken);
	public: void mASSIGN(bool _createToken);
	public: void mOR(bool _createToken);
	public: void mAND(bool _createToken);
	public: void mNOT(bool _createToken);
	public: void mREF(bool _createToken);
	public: void mADDR(bool _createToken);
	public: void mDIRECTIVE(bool _createToken);
	public: void mINCR(bool _createToken);
	public: void mDECR(bool _createToken);
	public: void mINS_START(bool _createToken);
	public: void mINS_END(bool _createToken);
	public: void mNUMERIC(bool _createToken);
	protected: void mDIGIT(bool _createToken);
	public: void mIDENT(bool _createToken);
	protected: void mLETTER(bool _createToken);
	public: void mSTRING(bool _createToken);
	public: void mCHAR(bool _createToken);
	public: void mCOMMENT(bool _createToken);
	public: void mCOMMENT_2(bool _createToken);
private:
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_2;
};

#endif /*INC_SourceLexer_hpp_*/
